/*
 * Copyright 2005-2010 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wamblee.inject;

/**
 * Interface used to perform injection with. An injector instance knows how to
 * perform injection in one or more specific classes.
 * 
 * @author Erik Brakkee
 */
public interface Injector {

    /**
     * Injects beans into a given component of the required class.
     * 
     * @param aComponent
     *            Component to inject into.
     * @throws IllegalArgumentException
     *             In case the argument passed is not supported for injection
     * @throws NullPointerException
     *             In case the argument passed is null.
     */
    void inject(Object aComponent);

}